'use strict';

var _assert = require('assert');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _generateDefinitions = require('../generateDefinitions');

var _generateDefinitions2 = _interopRequireDefault(_generateDefinitions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var expected = `
import t from "flow-runtime";
t.declare(t.type("$FlowIssue", t.$flowFixMe()));
t.declare(t.type("$FlowIgnore", t.$flowFixMe()));
t.declare(t.type("$FlowFixme", t.$flowFixMe()));
t.declare(t.type("$Fixme", t.$flowFixMe()));
t.declare(
  t.class(
    "Storage",
    t.object(
      t.property("length", t.number()),
      t.property(
        "getItem",
        t.function(t.param("key", t.string()), t.return(t.nullable(t.string())))
      ),
      t.property(
        "setItem",
        t.function(
          t.param("key", t.string()),
          t.param("data", t.string()),
          t.return(t.void())
        )
      ),
      t.property("clear", t.function(t.return(t.void()))),
      t.property(
        "removeItem",
        t.function(t.param("key", t.string()), t.return(t.void()))
      ),
      t.property(
        "key",
        t.function(
          t.param("index", t.number()),
          t.return(t.nullable(t.string()))
        )
      ),
      t.indexer("name", t.string(), t.nullable(t.string()))
    )
  )
);
`;

describe('Generate Definitions', function () {
  it('should generate definitions', _asyncToGenerator(function* () {
    var code = yield (0, _generateDefinitions2.default)([_path2.default.resolve(__dirname, '..', '..', 'example')]);
    (0, _assert.equal)(code.trim(), expected.trim());
  }));
});