'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.run = exports.description = exports.name = undefined;

var run = exports.run = function () {
  var _ref = _asyncToGenerator(function* (argv) {
    var _argvType = _flowRuntime2.default.ref(Argv);

    _flowRuntime2.default.warn(_flowRuntime2.default.param('argv', _argvType), argv);

    var config = yield (0, _loadFlowConfig2.default)();
    var definitionFolders = getDefinitionFolders(config);
    var definitions = yield (0, _crawlTypeDefinitions2.default)(definitionFolders);
    console.log(dumpModule(definitions));
  });

  return function run(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _babelGenerator = require('babel-generator');

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

var _prettier = require('prettier');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _crawlTypeDependencies = require('../crawlTypeDependencies');

var _crawlTypeDependencies2 = _interopRequireDefault(_crawlTypeDependencies);

var _crawlTypeDefinitions = require('../crawlTypeDefinitions');

var _crawlTypeDefinitions2 = _interopRequireDefault(_crawlTypeDefinitions);

var _loadFlowConfig = require('../loadFlowConfig');

var _loadFlowConfig2 = _interopRequireDefault(_loadFlowConfig);

var _buildProgram = require('../buildProgram');

var _buildProgram2 = _interopRequireDefault(_buildProgram);

var _flowConfigParser = require('flow-config-parser');

var _ = require('../');

var _Graph = require('../Graph');

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var FlowModule = _flowRuntime2.default.tdz(function () {
  return _Graph.FlowModule;
});

var Argv = _flowRuntime2.default.tdz(function () {
  return _.Argv;
});

var FlowConfig = _flowRuntime2.default.tdz(function () {
  return _flowConfigParser.FlowConfig;
});

var name = exports.name = 'list-defs';

var description = exports.description = 'Lists all the types found in definition files.';

_flowRuntime2.default.annotate(run, _flowRuntime2.default.function(_flowRuntime2.default.param('argv', _flowRuntime2.default.ref(Argv))));

;

function dumpModule(module) {
  var indent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

  var _moduleType = _flowRuntime2.default.ref(FlowModule);

  var _indentType = _flowRuntime2.default.number();

  var _returnType = _flowRuntime2.default.return(_flowRuntime2.default.string());

  _flowRuntime2.default.warn(_flowRuntime2.default.param('module', _moduleType), module);

  _flowRuntime2.default.warn(_flowRuntime2.default.param('indent', _indentType), indent);

  var lines = [module.name ? `Module: ${module.name}` : 'Global'];

  var count = 0;

  for (var _name in module.entities) {
    var entity = module.entities[_name];
    if (!entity.path) {
      continue;
    }
    if (_name !== 'module.exports') {
      count++;
    }
    lines.push(`  ${_name}`);
  }

  for (var _name2 in module.modules) {
    count++;
    lines.push(dumpModule(module.modules[_name2]));
  }

  if (count === 0) {
    return _flowRuntime2.default.warn(_returnType, '');
  }

  return _flowRuntime2.default.warn(_returnType, lines.filter(String).join('\n'));
}

_flowRuntime2.default.annotate(dumpModule, _flowRuntime2.default.function(_flowRuntime2.default.param('module', _flowRuntime2.default.ref(FlowModule)), _flowRuntime2.default.param('indent', _flowRuntime2.default.number()), _flowRuntime2.default.return(_flowRuntime2.default.string())));

function getDefinitionFolders(config) {
  var _configType = _flowRuntime2.default.nullable(_flowRuntime2.default.ref(FlowConfig));

  var _returnType2 = _flowRuntime2.default.return(_flowRuntime2.default.array(_flowRuntime2.default.string()));

  _flowRuntime2.default.warn(_flowRuntime2.default.param('config', _configType), config);

  var dirnames = [_path2.default.resolve(__dirname, '..', '..', 'flow-builtins')];
  if (config) {
    dirnames.push.apply(dirnames, _toConsumableArray(config.get('include')));
  }
  if (dirnames.length === 1) {
    dirnames.push('./flow-typed');
  }
  return _flowRuntime2.default.warn(_returnType2, dirnames);
}

_flowRuntime2.default.annotate(getDefinitionFolders, _flowRuntime2.default.function(_flowRuntime2.default.param('config', _flowRuntime2.default.nullable(_flowRuntime2.default.ref(FlowConfig))), _flowRuntime2.default.return(_flowRuntime2.default.array(_flowRuntime2.default.string()))));