'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.run = exports.description = exports.name = undefined;

var run = exports.run = function () {
  var _ref = _asyncToGenerator(function* (argv) {
    var _argvType = _flowRuntime2.default.ref(Argv);

    _flowRuntime2.default.warn(_flowRuntime2.default.param('argv', _argvType), argv);

    var _argv$_ = _toArray(argv._),
        searchPaths = _argv$_.slice(1);

    var _ref2 = yield (0, _crawlTypeDependencies2.default)(searchPaths),
        globalDependencies = _ref2.globalDependencies,
        moduleDependencies = _ref2.moduleDependencies;

    console.log('Global dependencies:');
    console.log(dumpDependencies(globalDependencies));
    for (var moduleName in moduleDependencies) {
      console.log(`Types imported from ${moduleName}:`);
      console.log(dumpDependencies(moduleDependencies[moduleName]));
    }
  });

  return function run(_x) {
    return _ref.apply(this, arguments);
  };
}();

var _crawlTypeDependencies = require('../crawlTypeDependencies');

var _crawlTypeDependencies2 = _interopRequireDefault(_crawlTypeDependencies);

var _ = require('../');

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var Argv = _flowRuntime2.default.tdz(function () {
  return _.Argv;
});

var name = exports.name = 'list-types';

var description = exports.description = 'Lists all the types referenced in source files.';

_flowRuntime2.default.annotate(run, _flowRuntime2.default.function(_flowRuntime2.default.param('argv', _flowRuntime2.default.ref(Argv))));

;

function dumpDependencies(obj) {
  var indent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

  var _objType = _flowRuntime2.default.object();

  var _indentType = _flowRuntime2.default.number();

  var _returnType = _flowRuntime2.default.return(_flowRuntime2.default.string());

  _flowRuntime2.default.warn(_flowRuntime2.default.param('obj', _objType), obj);

  _flowRuntime2.default.warn(_flowRuntime2.default.param('indent', _indentType), indent);

  return _flowRuntime2.default.warn(_returnType, `  ${Object.keys(obj).join('\n  ')}\n`);
}

_flowRuntime2.default.annotate(dumpDependencies, _flowRuntime2.default.function(_flowRuntime2.default.param('obj', _flowRuntime2.default.object()), _flowRuntime2.default.param('indent', _flowRuntime2.default.number()), _flowRuntime2.default.return(_flowRuntime2.default.string())));