'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _findFiles = require('./findFiles');

var _findFiles2 = _interopRequireDefault(_findFiles);

var _parseFileWithFlow = require('./parseFileWithFlow');

var _parseFileWithFlow2 = _interopRequireDefault(_parseFileWithFlow);

var _Graph = require('./Graph');

var _importAST = require('./importAST');

var _importAST2 = _interopRequireDefault(_importAST);

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = _flowRuntime2.default.annotate(function () {
  var _ref = _asyncToGenerator(function* (searchPaths) {
    var _searchPathsType = _flowRuntime2.default.array(_flowRuntime2.default.string());

    var _returnType = _flowRuntime2.default.return(_flowRuntime2.default.union(_flowRuntime2.default.ref(_Graph.FlowModule), _flowRuntime2.default.ref('Promise', _flowRuntime2.default.ref(_Graph.FlowModule))));

    _flowRuntime2.default.warn(_flowRuntime2.default.param('searchPaths', _searchPathsType), searchPaths);

    var filenames = yield _findFiles2.default.apply(undefined, _toConsumableArray(searchPaths));
    var files = yield Promise.all(filenames.map(_parseFileWithFlow2.default));

    var graph = new _Graph.FlowModule();

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = files[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var file = _step.value;

        (0, _importAST2.default)(graph, file);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return _flowRuntime2.default.warn(_returnType, graph);
  });

  function crawlTypeDefinitions(_x) {
    return _ref.apply(this, arguments);
  }

  return crawlTypeDefinitions;
}(), _flowRuntime2.default.function(_flowRuntime2.default.param('searchPaths', _flowRuntime2.default.array(_flowRuntime2.default.string())), _flowRuntime2.default.return(_flowRuntime2.default.ref('Promise', _flowRuntime2.default.ref(_Graph.FlowModule)))));