'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CrawledDependencies = exports.ModuleDependencyDict = exports.DependencyDict = undefined;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _findFiles = require('./findFiles');

var _findFiles2 = _interopRequireDefault(_findFiles);

var _parseFile = require('./parseFile');

var _parseFile2 = _interopRequireDefault(_parseFile);

var _collectExternalTypeReferences = require('./collectExternalTypeReferences');

var _collectExternalTypeReferences2 = _interopRequireDefault(_collectExternalTypeReferences);

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var DependencyDict = exports.DependencyDict = _flowRuntime2.default.type('DependencyDict', _flowRuntime2.default.object(_flowRuntime2.default.indexer('name', _flowRuntime2.default.string(), _flowRuntime2.default.number())));

var ModuleDependencyDict = exports.ModuleDependencyDict = _flowRuntime2.default.type('ModuleDependencyDict', _flowRuntime2.default.object(_flowRuntime2.default.indexer('name', _flowRuntime2.default.string(), DependencyDict)));

var CrawledDependencies = exports.CrawledDependencies = _flowRuntime2.default.type('CrawledDependencies', _flowRuntime2.default.object(_flowRuntime2.default.property('globalDependencies', DependencyDict), _flowRuntime2.default.property('moduleDependencies', ModuleDependencyDict)));

exports.default = _flowRuntime2.default.annotate(function () {
  var _ref = _asyncToGenerator(function* (searchPaths) {
    var _searchPathsType = _flowRuntime2.default.array(_flowRuntime2.default.string());

    var _returnType = _flowRuntime2.default.return(_flowRuntime2.default.union(CrawledDependencies, _flowRuntime2.default.ref('Promise', CrawledDependencies)));

    _flowRuntime2.default.warn(_flowRuntime2.default.param('searchPaths', _searchPathsType), searchPaths);

    var filenames = yield _findFiles2.default.apply(undefined, _toConsumableArray(searchPaths));
    var files = yield Promise.all(filenames.map(_parseFile2.default));

    var globalDependencies = {};
    var moduleDependencies = {};

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = files[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var file = _step.value;

        var _collectExternalTypeR = (0, _collectExternalTypeReferences2.default)(file),
            importedTypes = _collectExternalTypeR.importedTypes,
            globalTypes = _collectExternalTypeR.globalTypes;

        for (var key in importedTypes) {
          var source = importedTypes[key].source;

          if (/^\.\.?[\/|\\]/.test(source)) {
            continue;
          }
          var moduleExports = moduleDependencies[source];
          if (!moduleExports) {
            moduleExports = {};
            moduleDependencies[source] = moduleExports;
          }
          if (moduleExports[key]) {
            moduleExports[key]++;
          } else {
            moduleExports[key] = 1;
          }
        }

        for (var _key in globalTypes) {
          var value = globalTypes[_key];
          if (globalDependencies[_key]) {
            globalDependencies[_key] += value;
          } else {
            globalDependencies[_key] = value;
          }
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return _flowRuntime2.default.warn(_returnType, { globalDependencies, moduleDependencies });
  });

  function crawlTypeDependencies(_x) {
    return _ref.apply(this, arguments);
  }

  return crawlTypeDependencies;
}(), _flowRuntime2.default.function(_flowRuntime2.default.param('searchPaths', _flowRuntime2.default.array(_flowRuntime2.default.string())), _flowRuntime2.default.return(_flowRuntime2.default.ref('Promise', CrawledDependencies))));