'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var collectFiles = function () {
  var _ref2 = _asyncToGenerator(function* (fileOrDir, collected) {
    var _fileOrDirType = _flowRuntime2.default.string();

    var _collectedType = _flowRuntime2.default.array(_flowRuntime2.default.string());

    var _returnType2 = _flowRuntime2.default.return(_flowRuntime2.default.union(_flowRuntime2.default.array(_flowRuntime2.default.string()), _flowRuntime2.default.ref('Promise', _flowRuntime2.default.array(_flowRuntime2.default.string()))));

    _flowRuntime2.default.warn(_flowRuntime2.default.param('fileOrDir', _fileOrDirType), fileOrDir);

    _flowRuntime2.default.warn(_flowRuntime2.default.param('collected', _collectedType), collected);

    var stat = yield _util.fs.statAsync(fileOrDir);
    if (stat.isDirectory()) {
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = (yield _util.fs.readdirAsync(fileOrDir))[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var item = _step2.value;

          yield collectFiles(_path2.default.join(fileOrDir, item), collected);
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    } else if (collected.indexOf(fileOrDir) === -1 && /\.js(x|m)?$/.test(fileOrDir)) {
      collected.push(fileOrDir);
    }
    return _flowRuntime2.default.warn(_returnType2, collected);
  });

  return function collectFiles(_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();

var _util = require('./util');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = _flowRuntime2.default.annotate(function () {
  var _ref = _asyncToGenerator(function* () {
    var _inputType = _flowRuntime2.default.array(_flowRuntime2.default.string());

    var _returnType = _flowRuntime2.default.return(_flowRuntime2.default.union(_flowRuntime2.default.array(_flowRuntime2.default.string()), _flowRuntime2.default.ref('Promise', _flowRuntime2.default.array(_flowRuntime2.default.string()))));

    for (var _len = arguments.length, input = Array(_len), _key = 0; _key < _len; _key++) {
      input[_key] = arguments[_key];
    }

    _flowRuntime2.default.warn(_flowRuntime2.default.rest('input', _inputType), input);

    var found = [];
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = input[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var item = _step.value;

        yield collectFiles(item, found);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return _flowRuntime2.default.warn(_returnType, found);
  });

  function findFiles() {
    return _ref.apply(this, arguments);
  }

  return findFiles;
}(), _flowRuntime2.default.function(_flowRuntime2.default.rest('input', _flowRuntime2.default.array(_flowRuntime2.default.string())), _flowRuntime2.default.return(_flowRuntime2.default.ref('Promise', _flowRuntime2.default.array(_flowRuntime2.default.string())))));

_flowRuntime2.default.annotate(collectFiles, _flowRuntime2.default.function(_flowRuntime2.default.param('fileOrDir', _flowRuntime2.default.string()), _flowRuntime2.default.param('collected', _flowRuntime2.default.array(_flowRuntime2.default.string())), _flowRuntime2.default.return(_flowRuntime2.default.ref('Promise', _flowRuntime2.default.array(_flowRuntime2.default.string())))));