'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelGenerator = require('babel-generator');

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

var _prettier = require('prettier');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _crawlTypeDependencies = require('./crawlTypeDependencies');

var _crawlTypeDependencies2 = _interopRequireDefault(_crawlTypeDependencies);

var _crawlTypeDefinitions = require('./crawlTypeDefinitions');

var _crawlTypeDefinitions2 = _interopRequireDefault(_crawlTypeDefinitions);

var _loadFlowConfig = require('./loadFlowConfig');

var _loadFlowConfig2 = _interopRequireDefault(_loadFlowConfig);

var _buildProgram = require('./buildProgram');

var _buildProgram2 = _interopRequireDefault(_buildProgram);

var _flowConfigParser = require('flow-config-parser');

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var FlowConfig = _flowRuntime2.default.tdz(function () {
  return _flowConfigParser.FlowConfig;
});

exports.default = _flowRuntime2.default.annotate(function () {
  var _ref = _asyncToGenerator(function* (searchPaths) {
    var _searchPathsType = _flowRuntime2.default.array(_flowRuntime2.default.string());

    _flowRuntime2.default.warn(_flowRuntime2.default.param('searchPaths', _searchPathsType), searchPaths);

    var config = yield (0, _loadFlowConfig2.default)();
    var definitionFolders = getDefinitionFolders(config);

    var prog = (0, _buildProgram2.default)(config, (yield (0, _crawlTypeDependencies2.default)(searchPaths)), (yield (0, _crawlTypeDefinitions2.default)(definitionFolders)));

    var _generate = (0, _babelGenerator2.default)(prog),
        code = _generate.code;

    return (0, _prettier.format)(code);
  });

  function generateDefinitions(_x) {
    return _ref.apply(this, arguments);
  }

  return generateDefinitions;
}(), _flowRuntime2.default.function(_flowRuntime2.default.param('searchPaths', _flowRuntime2.default.array(_flowRuntime2.default.string()))));


function getDefinitionFolders(config) {
  var _configType = _flowRuntime2.default.nullable(_flowRuntime2.default.ref(FlowConfig));

  var _returnType = _flowRuntime2.default.return(_flowRuntime2.default.array(_flowRuntime2.default.string()));

  _flowRuntime2.default.warn(_flowRuntime2.default.param('config', _configType), config);

  var dirnames = [_path2.default.resolve(__dirname, '..', 'flow-builtins')];
  if (config) {
    dirnames.push.apply(dirnames, _toConsumableArray(config.get('include')));
  }
  if (dirnames.length === 1) {
    dirnames.push('./flow-typed');
  }
  return _flowRuntime2.default.warn(_returnType, dirnames);
}

_flowRuntime2.default.annotate(getDefinitionFolders, _flowRuntime2.default.function(_flowRuntime2.default.param('config', _flowRuntime2.default.nullable(_flowRuntime2.default.ref(FlowConfig))), _flowRuntime2.default.return(_flowRuntime2.default.array(_flowRuntime2.default.string()))));