'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Argv = undefined;

require('./typedefs');

var _minimist = require('minimist');

var _minimist2 = _interopRequireDefault(_minimist);

var _GenerateCommand = require('./commands/GenerateCommand');

var generate = _interopRequireWildcard(_GenerateCommand);

var _ListDefinitionsCommand = require('./commands/ListDefinitionsCommand');

var listDefinitions = _interopRequireWildcard(_ListDefinitionsCommand);

var _ListTypesCommand = require('./commands/ListTypesCommand');

var listTypes = _interopRequireWildcard(_ListTypesCommand);

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var minimistOutput = _flowRuntime2.default.tdz(function () {
  return _minimist.minimistOutput;
});

var Argv = exports.Argv = _flowRuntime2.default.type('Argv', _flowRuntime2.default.ref(minimistOutput));

var commands = {
  [generate.name]: generate,
  [listDefinitions.name]: listDefinitions,
  [listTypes.name]: listTypes
};

var Command = _flowRuntime2.default.type('Command', _flowRuntime2.default.object(_flowRuntime2.default.property('name', _flowRuntime2.default.string()), _flowRuntime2.default.property('description', _flowRuntime2.default.string()), _flowRuntime2.default.property('help', _flowRuntime2.default.function(_flowRuntime2.default.param('argv', Argv), _flowRuntime2.default.return(_flowRuntime2.default.string())), true), _flowRuntime2.default.property('run', _flowRuntime2.default.function(_flowRuntime2.default.param('argv', Argv), _flowRuntime2.default.return(_flowRuntime2.default.any())))));

exports.default = _flowRuntime2.default.annotate(function () {
  var _ref = _asyncToGenerator(function* (args) {
    var _argsType = _flowRuntime2.default.array(_flowRuntime2.default.string());

    _flowRuntime2.default.warn(_flowRuntime2.default.param('args', _argsType), args);

    var argv = _flowRuntime2.default.warn(Argv, (0, _minimist2.default)(args));
    var command = argv._.length === 0 ? undefined : commands[argv._[0]];

    if (argv.help || !command) {
      showUsage(argv);
      return;
    }
    try {
      var result = command.run(argv);
      if (result && typeof result.then === 'function') {
        yield result;
      }
    } catch (e) {
      console.error(e.stack);
    }
  });

  function run(_x) {
    return _ref.apply(this, arguments);
  }

  return run;
}(), _flowRuntime2.default.function(_flowRuntime2.default.param('args', _flowRuntime2.default.array(_flowRuntime2.default.string()))));


function showUsage(argv) {
  var _argvType = Argv;

  _flowRuntime2.default.warn(_flowRuntime2.default.param('argv', _argvType), argv);

  console.error(`Usage: flow-runtime [OPTIONS]`);
  for (var key in commands) {
    var command = commands[key];
    console.error(`\t${command.name}:\t${command.description}`);
  }
}

_flowRuntime2.default.annotate(showUsage, _flowRuntime2.default.function(_flowRuntime2.default.param('argv', Argv)));