'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babylon = require('babylon');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _flowRuntime = require('flow-runtime');

var _flowRuntime2 = _interopRequireDefault(_flowRuntime);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var FileNode = _flowRuntime2.default.type('FileNode', _flowRuntime2.default.object(_flowRuntime2.default.property('type', _flowRuntime2.default.string()), _flowRuntime2.default.property('filename', _flowRuntime2.default.string())));

exports.default = _flowRuntime2.default.annotate(function () {
  var _ref = _asyncToGenerator(function* (filename) {
    var _filenameType = _flowRuntime2.default.string();

    var _returnType = _flowRuntime2.default.return(_flowRuntime2.default.union(FileNode, _flowRuntime2.default.ref('Promise', FileNode)));

    _flowRuntime2.default.warn(_flowRuntime2.default.param('filename', _filenameType), filename);

    var input = yield _util.fs.readFileAsync(filename, 'utf8');
    var parsed = (0, _babylon.parse)(input, {
      filename,
      sourceType: 'module',
      allowReturnOutsideFunction: true,
      plugins: ['jsx', 'flow', 'doExpressions', 'objectRestSpread', 'decorators', 'classProperties', 'exportExtensions', 'asyncGenerators', 'functionBind', 'functionSent']
    });
    parsed.filename = _path2.default.resolve(filename);
    return _flowRuntime2.default.warn(_returnType, parsed);
  });

  function parseFile(_x) {
    return _ref.apply(this, arguments);
  }

  return parseFile;
}(), _flowRuntime2.default.function(_flowRuntime2.default.param('filename', _flowRuntime2.default.string()), _flowRuntime2.default.return(_flowRuntime2.default.ref('Promise', FileNode))));